/**
 * Задатак 2. (фебруар 2014)
 * Написати програм на програмском језику C који уређује дате правоугаонике по
 * неопадајућој вредности површине. Подаци о правоугаоницима се читају са
 * стандардног улаза. Број правоугаоника није унапред познат, па је податке о
 * правоугаоницима неопходно чувати у листи. Један правоугаоник је описан
 * координатама горњег левог и доњег десног темана. Уређену листу правоугаоника
 * исписати на стандардни излаз, тако да се у сваком реду испишу подаци о тачно
 * једном правоугаонику. Учитавање, уређивање (сортирање) и испис резултата
 * имплементирати у три одвојена потпрограма. Потпрограми са програмом
 * комуницирају искључиво преко аргумената и повратне вредности потпрограма.
 *
 * НАПОМЕНА: Задатак је измењен тако што је уведена претпоставка да се уместо
 * уланчане листе користи низ фиксне дужине, како би се демонстрирало како се
 * може решити коришћењем статичког низа.
 *
 * Аутор: Игор Лукић
 */

#include <stdio.h>

typedef struct {
    float x, y;
} Tacka;

typedef struct {
    Tacka a, b;
} Pravougaonik;

#define DUZ 100

int ucitaj(Pravougaonik p[], int *pn) {
    int i, n;

    printf("unesite broj pravougaonika");
    scanf("%d", &n);

    // ako je uneta pogresna vrednost vracamo se
    if (n <= 0 || n > DUZ) return 0;

    printf("unesite elemente niza");
    for (i = 0; i < n; i++) {
        scanf(
            "%f %f %f %f",
            &p[i].a.x,
            &p[i].a.y,
            &p[i].b.x,
            &p[i].b.y
        );
    }

    *pn = n;

    return 1;
}

float povrsina(Pravougaonik p) {
    return (p.b.x - p.a.x) * (p.a.y - p.b.y);
}

void sortiraj(Pravougaonik p[], int n) {
    int i, j;

    for (i = 0; i < n-1; i++) {
        for (j = i+1; j < n; j++) {
            if (povrsina(p[i]) > povrsina(p[j])) {
                Pravougaonik pr;
                pr = p[i];
                p[i] = p[j];
                p[j] = pr;
            }
        }
    }
}

void ispis(Pravougaonik p[], int n) {
    int i;

    for (i = 0; i < n; i++) {
        printf(
            "(%f,%f)(%f,%f)\n",
            p[i].a.x,
            p[i].a.y,
            p[i].b.x,
            p[i].b.y
        );
    }
}

void main() {
    Pravougaonik p[DUZ];
    int n, i;
    int uspeh;

    uspeh = ucitaj(p, &n);
    if (uspeh) {
        sortiraj(p, n);
        ispis(p, n);
    }
}